﻿namespace HeuristicLab.BenchmarkSuite.ERC {
  using HeuristicLab.Common;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class StringErcOptions : ErcOption<string> {

    public StringErcOptions() { }

    [StorableConstructor]
    public StringErcOptions(bool deserializing) : base(deserializing) { }

    public StringErcOptions(StringErcOptions origin, Cloner cloner) : base(origin, cloner) {
      AllowLowercaseLetters = origin.AllowLowercaseLetters;
      AllowUppercaseLetters = origin.AllowUppercaseLetters;
      AllowSpace = origin.AllowSpace;
      SpacePropability = origin.SpacePropability;
    }

    [Storable]
    public bool AllowLowercaseLetters { get; set; }
    [Storable]
    public bool AllowUppercaseLetters { get; set; }
    [Storable]
    public bool AllowSpace { get; set; }
    [Storable]
    public double SpacePropability { get; set; }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new StringErcOptions(this, cloner);
    }
  }
}
