﻿namespace HeuristicLab.BenchmarkSuite {
  using System.Linq;

  using HeuristicLab.Common;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class Example : DeepCloneable {
    public Example() {
      this.InputInt = new long[0];
      this.InputFloat = new double[0];
      this.InputBoolean = new bool[0];
      this.OutputInt = this.InputInt;
      this.OutputFloat = this.InputFloat;
      this.OutputBoolean = this.InputBoolean;
    }

    public Example(Example origin, Cloner cloner) : base(origin, cloner) {
      origin.CopyTo(this);
    }

    [StorableConstructor]
    public Example(bool deserializing) { }

    public void CopyTo(Example example) {
      example.InputArgs = InputArgs.ToArray();
      example.OutputArgs = OutputArgs.ToArray();

      example.InputBoolean = InputBoolean.ToArray();
      example.InputInt = InputInt.ToArray();
      example.InputFloat = InputFloat.ToArray();

      example.OutputBoolean = OutputBoolean.ToArray();
      example.OutputInt = OutputInt.ToArray();
      example.OutputFloat = OutputFloat.ToArray();
    }

    [Storable]
    public string[] InputArgs { get; set; }
    [Storable]
    public string[] OutputArgs { get; set; }

    [Storable]
    public long[] InputInt { get; set; }
    [Storable]
    public double[] InputFloat { get; set; }
    [Storable]
    public bool[] InputBoolean { get; set; }
    [Storable]
    public char[] InputChar { get; set; }
    [Storable]
    public string[] InputString { get; set; }

    [Storable]
    public long[] OutputInt { get; set; }
    [Storable]
    public double[] OutputFloat { get; set; }
    [Storable]
    public bool[] OutputBoolean { get; set; }
    [Storable]
    public char[] OutputChar { get; set; }
    [Storable]
    public string[] OutputString { get; set; }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new Example(this, cloner);
    }
  }
}
